/*
 * Created on 09.03.2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package personalAbteilung;

import interfaces.Anschrift;

import java.util.ArrayList;
import java.util.List;

import stammdaten.GeschaeftsAdresse;
import stammdaten.StandardAdresse.StandardAnschrift;
import exceptions.DuplicateKeyException;

/**
 * @author administrator
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class AdressDaten {

	public static void main(String[] args) {
		List adressen = new ArrayList();
		// einpflege der Adressdaten
		adressEingabe(adressen);
		mitarbeiterGehaltsAusgabe(adressen);
	}
	
	private static void adressEingabe(List adressen) {
		try {	
			// 1. Adresse
			// StandardAnschrift erzeugen
			StandardAnschrift anschrift = new StandardAnschrift("Ottostrasse", "1", "12345", "Ottohausen", "Ostfriesland");	
			// neue Standardadresse mit der erzeugten StandardAnschrift
			GeschaeftsAdresse adresse = new GeschaeftsAdresse(new Integer(1),"Karl","Otto","TA1",120,anschrift);
			// LieferAnschrift erzeugen
			anschrift = new StandardAnschrift("Karl-May-Strasse", "2", "56789", "Karlmayhausen", "Nordfriesland");
			// LieferAnschrift zur Adresse hinzufgen
			String anschriftsTyp =Anschrift.LIEFER_ANSCHRIFT;
			try {
				adresse.addAnschrift(anschriftsTyp, anschrift);
			} catch (DuplicateKeyException e) {
				ExceptionHandler.handleDuplicateKeyException(adresse, anschriftsTyp, anschrift, e);
			}
			// Adresse zur Adressliste hinzufgen
			adressen.add(adresse);
					
			// 2. Adresse
			// StandardAnschrift erzeugen
			anschrift = new StandardAnschrift("Karlstrasse", "2", "56789", "Karlhausen", "Westfriesland");
			// neue Standardadresse mit der erzeugten StandardAnschrift
			adresse = new GeschaeftsAdresse(new Integer(2),"Dieter","Karl","AT1",90,anschrift);
			// LieferAnschrift erzeugen
			anschrift = new StandardAnschrift("Karl-May-Strasse", "2", "56789", "Karlmayhausen", "Nordfriesland");
			// LieferAnschrift zur Adresse hinzufgen
			try {
				adresse.addAnschrift(anschriftsTyp, anschrift);
			} catch (DuplicateKeyException e) {
				ExceptionHandler.handleDuplicateKeyException(adresse, anschriftsTyp, anschrift, e);
			}
			// 2. LieferAnschrift erzeugen
			anschrift = new StandardAnschrift("Karl-Benz-Strasse", "2", "56789", "Karlbenzhausen", "Sdfriesland");
			// 2. LieferAnschrift zur Adresse hinzufgen
			try {
				adresse.addAnschrift(anschriftsTyp, anschrift);
			} catch (DuplicateKeyException e) {
				ExceptionHandler.handleDuplicateKeyException(adresse, anschriftsTyp, anschrift, e);
			}
			
			// Wir provozieren eine ArithmeticException
			// int a = 10 / 0;

			// 3. LieferAnschrift erzeugen
			anschrift = new StandardAnschrift("Carl-Bosch-Strasse", "2", "56789", "Carlboschhausen", "Sddeutschland");
			// 3. LieferAnschrift zur Adresse hinzufgen
			try {
				adresse.addAnschrift(anschriftsTyp, anschrift);
			} catch (DuplicateKeyException e) {
				ExceptionHandler.handleDuplicateKeyException(adresse, anschriftsTyp, anschrift, e);
			}
			// Adresse zur Adressliste hinzufgen
			adressen.add(adresse);
	
		} catch (RuntimeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			String output = "";
			for (int i = 0; i < adressen.size(); i++) {
				output =  output + adressen.get(i).toString() + ", ";
			}
			System.out.println(output);
		}
	}

	private static void mitarbeiterGehaltsAusgabe(List adressen) {
		
	}
}
